#!/bin/bash

set -e

# Directory where this script is located.
scriptDir=$(dirname -- "$(readlink -f -- "$BASH_SOURCE")")
initrdDir="${scriptDir}/crypt-initrd-extra-files"

# Copy api server binary to initrd build dir.
cp "${scriptDir}/cryptops/bin/cryptops-api" "${initrdDir}/usr/bin/cryptops-api"

# Store api server version information.
versionInfoFile="${initrdDir}/etc/cryptops-api/version.txt"
cd "${scriptDir}/cryptops"
git rev-parse --abbrev-ref HEAD > "${versionInfoFile}"
git log -1 >> "${versionInfoFile}"

# Copy api client script and associated binaries to initrd build dir.
cp "${scriptDir}/cryptops/cryptops-client/cryptops-client" "${initrdDir}/usr/bin/cryptops-client"
cp "${scriptDir}/cryptops/cryptops-client/local/jq" "${initrdDir}/usr/bin/jq"

# Store client version information.
versionInfoFile="${initrdDir}/etc/cryptops-client/version.txt"
cd "${scriptDir}/cryptops/cryptops-client"
git rev-parse --abbrev-ref HEAD > "${versionInfoFile}"
git log -1 >> "${versionInfoFile}"

# Copy ssl certificates from builder to initrd.
certsDir="${initrdDir}/etc/ssl/certs"
mkdir -p "${certsDir}"
cp "/etc/ssl/certs/ca-certificates.crt" "${certsDir}/"
